Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 486)
+++ palm/trunk/SOURCE/modules.f90	(revision 493)
@@ -5,5 +5,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +netcdf_data_format, -netcdf_64bit, -netcdf_64bit_3d
 !
 ! Former revisions:
@@ -23,5 +23,5 @@
 ! 410 2009-12-04 17:05:40Z letzel
 ! masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
-! mask_scale|_x|y|z, masks, netcdf_format_mask[_av], skip_time_domask
+! mask_scale|_x|y|z, masks, skip_time_domask
 !
 ! 388 2009-09-23 09:40:33Z raasch
@@ -379,7 +379,7 @@
                 intermediate_timestep_count, intermediate_timestep_count_max, &
                 iran = -1234567, last_dt_change = 0, masks = 0, &
-                maximum_grid_level, &
-                max_pr_user = 0, mgcycles = 0, mg_cycles = -1, &
-                mg_switch_to_pe0_level = 0, mid, ngsrb = 2, nsor = 20, &
+                maximum_grid_level, max_pr_user = 0, mgcycles = 0, &
+                mg_cycles = -1, mg_switch_to_pe0_level = 0, mid, &
+                netcdf_data_format = 2, ngsrb = 2, nsor = 20, &
                 nsor_ini = 100, n_sor, normalizing_region = 0, &
                 nz_do1d, nz_do3d = -9999, outflow_damping_width = -1, &
@@ -396,7 +396,4 @@
                 mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
                 mask_start_l(max_masks,3) = -1, &
-                nc_format_mask(1:max_masks,0:1), &
-                netcdf_format_mask(1:max_masks) = 1, &
-                netcdf_format_mask_av(1:max_masks) = 1, &
                 pt_vertical_gradient_level_ind(10) = -9999, &
                 q_vertical_gradient_level_ind(10) = -9999, &
@@ -430,6 +427,5 @@
                 disturbance_created = .FALSE., &
                 first_call_advec_particles = .TRUE., &
-                force_print_header = .FALSE., format_parallel_io = .FALSE., &
-		galilei_transformation = .FALSE.,&
+                force_print_header = .FALSE., galilei_transformation = .FALSE.,&
                 humidity = .FALSE., humidity_remote = .FALSE., &
                 inflow_l = .FALSE., inflow_n = .FALSE., &
@@ -437,6 +433,5 @@
                 iso2d_output = .FALSE., large_scale_subsidence = .FALSE., &
                 mg_switch_to_pe0 = .FALSE., &
-                netcdf_output = .FALSE., netcdf_64bit = .FALSE., &
-                netcdf_64bit_3d = .TRUE., ocean = .FALSE., &
+                netcdf_output = .FALSE., ocean = .FALSE., &
                 outflow_l = .FALSE., outflow_n = .FALSE., outflow_r = .FALSE., &
                 outflow_s = .FALSE., passive_scalar = .FALSE., &
Index: palm/trunk/SOURCE/netcdf.f90
===================================================================
--- palm/trunk/SOURCE/netcdf.f90	(revision 486)
+++ palm/trunk/SOURCE/netcdf.f90	(revision 493)
@@ -7,5 +7,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Extensions for NetCDF4 output
 !
 ! Former revisions:
@@ -1093,5 +1093,14 @@
                                      'units', TRIM( do3d_unit(av,i) ) )
              CALL handle_netcdf_error( 'netcdf', 357 )
-
+#if defined( __netcdf4 )
+!
+!--          Set collective io operations for parallel io
+             IF ( netcdf_data_format > 2 )  THEN
+                nc_stat = NF90_VAR_PAR_ACCESS( id_set_3d(av),     &
+                                               id_var_do3d(av,i), &
+                                               NF90_COLLECTIVE )
+                CALL handle_netcdf_error( 'netcdf', 445 )
+             ENDIF
+#endif
              i = i + 1
 
@@ -1299,4 +1308,14 @@
                                        id_var_do3d(av,i) )
              CALL handle_netcdf_error( 'netcdf', 95 )
+#if defined( __netcdf4 )
+!
+!--          Set collective io operations for parallel io
+             IF ( netcdf_data_format > 2 )  THEN
+                nc_stat = NF90_VAR_PAR_ACCESS( id_set_3d(av),     &
+                                               id_var_do3d(av,i), &
+                                               NF90_COLLECTIVE )
+                CALL handle_netcdf_error( 'netcdf', 453 )
+             ENDIF
+#endif
              i = i + 1
           ENDDO
@@ -1644,4 +1663,14 @@
                                         'units', TRIM( do2d_unit(av,i) ) )
                 CALL handle_netcdf_error( 'netcdf', 354 ) 
+#if defined( __netcdf4 )
+!
+!--             Set collective io operations for parallel io
+                IF ( netcdf_data_format > 2 )  THEN
+                   nc_stat = NF90_VAR_PAR_ACCESS( id_set_xy(av),     &
+                                                  id_var_do2d(av,i), &
+                                                  NF90_COLLECTIVE )
+                   CALL handle_netcdf_error( 'netcdf', 448 )
+                ENDIF
+#endif
              ENDIF
 
@@ -1940,4 +1969,14 @@
                                           id_var_do2d(av,i) )
                 CALL handle_netcdf_error( 'netcdf', 138 )
+#if defined( __netcdf4 )
+!
+!--             Set collective io operations for parallel io
+                IF ( netcdf_data_format > 2 )  THEN
+                   nc_stat = NF90_VAR_PAR_ACCESS( id_set_xy(av),     &
+                                                  id_var_do2d(av,i), &
+                                                  NF90_COLLECTIVE )
+                   CALL handle_netcdf_error( 'netcdf', 454 )
+                ENDIF
+#endif
              ENDIF
              i = i + 1
@@ -2212,4 +2251,30 @@
                                         'units', TRIM( do2d_unit(av,i) ) )
                 CALL handle_netcdf_error( 'netcdf', 355 )
+#if defined( __netcdf4 )
+!
+!--             Set independent io operations for parallel io. Collective io
+!--             is only allowed in case of a 1d-decomposition along x, because
+!--             otherwise, not all PEs have output data.
+                IF ( netcdf_data_format > 2 )  THEN
+                   IF ( npey == 1 )  THEN
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_xz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+                   ELSE
+!
+!--                   ATTENTION: Due to a probable bug in the NetCDF4
+!--                              installation, independet output does not work
+!--                              A workaround is used in data_output_2d on those
+!--                              PEs having no data
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_xz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+!                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_xz(av),     &
+!                                                     id_var_do2d(av,i), &
+!                                                     NF90_INDEPENDENT )
+                   ENDIF
+                   CALL handle_netcdf_error( 'netcdf', 449 )
+                ENDIF
+#endif
              ENDIF
 
@@ -2478,4 +2543,30 @@
                                           id_var_do2d(av,i) )
                 CALL handle_netcdf_error( 'netcdf', 177 )
+#if defined( __netcdf4 )
+!
+!--             Set independent io operations for parallel io. Collective io
+!--             is only allowed in case of a 1d-decomposition along x, because
+!--             otherwise, not all PEs have output data.
+                IF ( netcdf_data_format > 2 )  THEN
+                   IF ( npey == 1 )  THEN
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_xz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+                   ELSE
+!
+!--                   ATTENTION: Due to a probable bug in the NetCDF4
+!--                              installation, independet output does not work
+!--                              A workaround is used in data_output_2d on those
+!--                              PEs having no data
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_xz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+!                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_xz(av),     &
+!                                                     id_var_do2d(av,i), &
+!                                                     NF90_INDEPENDENT )
+                   ENDIF
+                   CALL handle_netcdf_error( 'netcdf', 455 )
+                ENDIF
+#endif
              ENDIF
              i = i + 1
@@ -2750,4 +2841,30 @@
                                         'units', TRIM( do2d_unit(av,i) ) )
                 CALL handle_netcdf_error( 'netcdf', 356 )
+#if defined( __netcdf4 )
+!
+!--             Set independent io operations for parallel io. Collective io
+!--             is only allowed in case of a 1d-decomposition along y, because
+!--             otherwise, not all PEs have output data.
+                IF ( netcdf_data_format > 2 )  THEN
+                   IF ( npex == 1 )  THEN
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_yz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+                   ELSE
+!
+!--                   ATTENTION: Due to a probable bug in the NetCDF4
+!--                              installation, independet output does not work
+!--                              A workaround is used in data_output_2d on those
+!--                              PEs having no data
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_yz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+!                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_yz(av),     &
+!                                                     id_var_do2d(av,i), &
+!                                                     NF90_INDEPENDENT )
+                   ENDIF
+                   CALL handle_netcdf_error( 'netcdf', 450 )
+                ENDIF
+#endif
              ENDIF
 
@@ -3014,4 +3131,30 @@
                                           id_var_do2d(av,i) )
                 CALL handle_netcdf_error( 'netcdf', 216 )
+#if defined( __netcdf4 )
+!
+!--             Set independent io operations for parallel io. Collective io
+!--             is only allowed in case of a 1d-decomposition along y, because
+!--             otherwise, not all PEs have output data.
+                IF ( netcdf_data_format > 2 )  THEN
+                   IF ( npex == 1 )  THEN
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_yz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+                   ELSE
+!
+!--                   ATTENTION: Due to a probable bug in the NetCDF4
+!--                              installation, independet output does not work
+!--                              A workaround is used in data_output_2d on those
+!--                              PEs having no data
+                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_yz(av),     &
+                                                     id_var_do2d(av,i), &
+                                                     NF90_COLLECTIVE )
+!                      nc_stat = NF90_VAR_PAR_ACCESS( id_set_yz(av),     &
+!                                                     id_var_do2d(av,i), &
+!                                                     NF90_INDEPENDENT )
+                   ENDIF
+                   CALL handle_netcdf_error( 'netcdf', 450 )
+                ENDIF
+#endif
              ENDIF
              i = i + 1
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 486)
+++ palm/trunk/SOURCE/parin.f90	(revision 493)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +netcdf_data_format in d3par, -netcdf_64bit, -netcdf_64bit_3d
 !
 ! Former revisions:
@@ -16,5 +16,5 @@
 ! 410 2009-12-04 17:05:40Z letzel
 ! masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
-! mask_scale_x|y|z, masks, netcdf_format_mask[_av], skip_time_domask
+! mask_scale_x|y|z, masks, skip_time_domask
 !
 ! 291 2009-04-16 12:07:26Z raasch
@@ -61,6 +61,4 @@
 ! 20 2007-02-26 00:12:32Z raasch
 ! +top_heatflux, use_top_fluxes in inipar
-!
-! -netcdf_64bit_3d
 !
 ! 3 2007-02-13 11:30:58Z raasch
@@ -208,6 +206,5 @@
                        mask_19_z_loop, mask_20_z_loop, &
                        mg_cycles, mg_switch_to_pe0_level, &
-                       netcdf_64bit, netcdf_64bit_3d, &
-                       netcdf_format_mask, netcdf_format_mask_av, &
+                       netcdf_data_format, &
                        ngsrb, normalizing_region, npex, npey, nsor, nz_do3d, &
                        omega_sor, &
Index: palm/trunk/SOURCE/user_statistics.f90
===================================================================
--- palm/trunk/SOURCE/user_statistics.f90	(revision 486)
+++ palm/trunk/SOURCE/user_statistics.f90	(revision 493)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bugfix: timeseries data have to be collected by PE0
 !
 ! Former revisions:
@@ -25,4 +25,5 @@
     USE arrays_3d
     USE indices
+    USE netcdf_control
     USE statistics
     USE user
@@ -33,4 +34,6 @@
 
     INTEGER ::  i, j, k, sr, tn
+
+    REAL, DIMENSION(dots_num_palm+1:dots_max) ::  ts_value_l
 
 
@@ -70,6 +73,24 @@
 !--    creates two time series for the absolut values of the horizontal
 !--    velocities u and v.
-!       ts_value(dots_num_palm+1,sr) = ABS( u_max )
-!       ts_value(dots_num_palm+2,sr) = ABS( v_max )
+!       ts_value_l = 0.0
+!       ts_value_l(dots_num_palm+1,sr) = ABS( u_max )
+!       ts_value_l(dots_num_palm+2,sr) = ABS( v_max )
+!
+!--     Collect / send values to PE0, because only PE0 outputs the time series.
+!--     CAUTION: Collection is done by taking the sum over all processors.
+!--              You may have to normalize this sum, depending on the quantity
+!--              that you like to calculate. For serial runs, nothing has to be
+!--              done.
+!--     HINT: If the time series value that you are calculating has the same
+!--           value on all PEs, you can omit the MPI_ALLREDUCE call and
+!--           assign ts_value(dots_num_palm+1:,sr) = ts_value_l directly.
+!#if defined( __parallel )
+!       CALL MPI_ALLREDUCE( ts_value_l(dots_num_palm+1),                       &
+!                           ts_value(dots_num_palm+1,sr),                      &
+!                           dots_max-dots_num_palm, MPI_REAL, MPI_SUM, comm2d, &
+!                           ierr )
+!#else
+!       ts_value(dots_num_palm+1:,sr) = ts_value_l
+!#endif
 
     ENDIF
